import { RestApiRequestHandler, RestApiRoute, RestPathParams, RestQueryParams, RestRequestBody, RestRequestHeaders, RestRequireAuthentication, RestResponseBody } from './types';
import { APIGatewayProxyEvent, APIGatewayProxyResult } from 'aws-lambda';
export declare class RestApi {
    private routes;
    addRouteHandler<PathParams extends RestPathParams = never, QueryParams extends RestQueryParams = never, RequestHeaders extends RestRequestHeaders = never, RequestBody extends RestRequestBody = never, ResponseBody extends RestResponseBody = never, RequireAuthentication extends RestRequireAuthentication = never>(route: RestApiRoute<PathParams, QueryParams, RequestHeaders, RequestBody, ResponseBody, RequireAuthentication>, requestHandler: RestApiRequestHandler<PathParams, QueryParams, RequestHeaders, RequestBody, ResponseBody, RequireAuthentication>): this;
    handleRequest(proxyEvent: APIGatewayProxyEvent): Promise<APIGatewayProxyResult>;
    private getMatchingRouteHandlers;
    private getMatchingRouteHandler;
    private extractPathParams;
    private extractQueryParams;
}
