import { RestPathParams } from './RestPathParams';
import { RestRequestBody } from './RestRequestBody';
import { RestResponseBody } from './RestResponseBody';
import { RestQueryParams } from './RestQueryParams';
import { RestRequestHeaders } from './RestRequestHeaders';
import { RestRequireAuthentication } from './RestRequireAuthentication';
export type RestHttpMethod = 'GET' | 'POST' | 'DELETE' | 'PATCH' | 'PUT' | 'OPTIONS';
export type RestRoutePath = `/${string}`;
export interface RestApiRoute<PathParams extends RestPathParams = never, QueryParams extends RestQueryParams = never, RequestHeaders extends RestRequestHeaders = never, RequestBody extends RestRequestBody = never, ResponseBody extends RestResponseBody = never, RequireAuthentication extends RestRequireAuthentication = never> {
    method: RestHttpMethod;
    path: RestRoutePath;
    buildUrl: (pathParams: PathParams, queryParams: QueryParams) => RestRoutePath;
    requireAuthentication: RequireAuthentication;
    __types?: {
        RequestHeaders: RequestHeaders;
        RequestBody: RequestBody;
        ResponseBody: ResponseBody;
    };
}
export type RestApiRouteBase = RestApiRoute<RestPathParams, RestQueryParams, RestRequestHeaders, RestRequestBody, RestResponseBody, RestRequireAuthentication>;
