import { RestApiRoute } from './RestApiRoute';
import { RestApiRequestHandler } from './RestApiRequestHandler';
import { RestPathParams } from './RestPathParams';
import { RestQueryParams } from './RestQueryParams';
import { RestRequestBody } from './RestRequestBody';
import { RestResponseBody } from './RestResponseBody';
import { RestRequestHeaders } from './RestRequestHeaders';
import { RestRequireAuthentication } from './RestRequireAuthentication';
export interface RestApiRouteHandler<PathParams extends RestPathParams = never, QueryParams extends RestQueryParams = never, RequestHeaders extends RestRequestHeaders = never, RequestBody extends RestRequestBody = never, ResponseBody extends RestResponseBody = never, RequireAuthentication extends RestRequireAuthentication = never> {
    route: RestApiRoute<PathParams, QueryParams, RequestHeaders, RequestBody, ResponseBody, RequireAuthentication>;
    requestHandler: RestApiRequestHandler<PathParams, QueryParams, RequestHeaders, RequestBody, ResponseBody, RequireAuthentication>;
}
export type RestApiRouteHandlerBase = RestApiRouteHandler<RestPathParams, RestQueryParams, RestRequestHeaders, RestRequestBody, RestResponseBody, RestRequireAuthentication>;
